//+------------------------------------------------------------------+
//|                                                       TRIFDN.mq4 |
//|                                  Copyright sakymns test program. |
//|                                       http://twitter.com/sakymns |
//+------------------------------------------------------------------+
#property copyright "Copyright sakymns test program."
#property link      "http://twitter.com/sakymns"

#define MAGIC 20101208           //MAGICio[

//USDJPY24 150
//EURUSD26 80

string Posi;
bool CloseSig;
bool End1 = false;
bool End2 = false;
bool End3 = false;
int oldV = 99999;
bool chkflg = true;
double PRC = 0;
int Currencychk = 0;
bool SendOK = true;

extern int HANI = 16;
extern int SONGIGI = 150;
extern int RSIsongiriL = 70;
extern int RSIsongiriS = 35;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   if (AccountCurrency()=="USD") Currencychk = 1000;
   else if(AccountCurrency()=="JPY") Currencychk = 100000;
   else  Currencychk = 1000;   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int GLerror;


   if (chkflg == true && AccountBalance() == 0)
   {
      Alert("0$") ;
      chkflg = false;
   }
   
   if (AccountBalance() <= 0) return(0);


      //LotvZ
   double Lots;
   GLerror = GetLastError();
   if (GLerror == 134 || GLerror == 4051)
   {
      Alert(GetLastError());
   }
   else
   {
         //bgvZ
      Lots = NormalizeDouble(AccountBalance() / Currencychk * 0.10,1);
      if (Lots > AccountBalance() * 0.11)
      {
         Lots = Lots - 0.1;
      }
   }

   if (Lots == 0)
   {
      Lots = 0.1;
   }

   while (true)
   {
      if(IsTradeContextBusy())
      {
         Sleep(5000);
      }
      else
      {
         break;
      }
   }

   
   
         //|WV̖mF
   int posicount = 0;
   for (int pos = 0;pos < OrdersTotal();pos++)
   {
      if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES) == false)
      {
         continue;            //̃|WVցB
      }
      if(OrderMagicNumber() != MAGIC || OrderSymbol() != Symbol()) continue;
      
      if(OrderType() == OP_BUY)
      {
         Posi = "L";
         PRC = OrderOpenPrice();
      }
      else if (OrderType() == OP_SELL)
      {
         Posi = "S";
         PRC = OrderOpenPrice();
      }
      posicount ++;
   }

   if (posicount != 0)
   {
      if (Posi == "L" && (iRSI(NULL,0,HANI,PRICE_CLOSE,0) >= RSIsongiriL || PRC - SONGIGI * Point >= Bid)) 
      {
         ClosePosi();
         Posi = "";
         PRC = 0;
      }
      else if (Posi == "S" && (iRSI(NULL,0,HANI,PRICE_CLOSE,0) <= RSIsongiriS || PRC + SONGIGI * Point <= Bid))
      {
         ClosePosi();      
         Posi = "";
         PRC = 0;
      }  
   }
/*   else
   {
      Posi = "";
      PRC = 0;
   }
*/

   int newV = Volume[0];
   if (newV < oldV)
   {
      //R`FbN
      int i = 0;
      int FiboTop = iHighest(NULL,0,MODE_HIGH,HANI,i);

      while(true)
      {
         FiboTop = iHighest(NULL,0,MODE_HIGH,HANI,i);
      
         if (FiboTop == iHighest(NULL,0,MODE_HIGH,HANI,FiboTop))
         {
            break;   
         }
         else 
         {
            i ++;
         }
      }   

      //J`FbN
      int j = 0;
      int FiboBottom = iLowest(NULL,0,MODE_LOW,HANI,j + FiboTop);

      while(true)
      {
         FiboBottom = iLowest(NULL,0,MODE_LOW,HANI,j + FiboTop);
      
         if (FiboBottom == iLowest(NULL,0,MODE_LOW,HANI,FiboBottom))
         {
                           //ǂǂ킩ȂǁAmȒ߂ĂȂ
            FiboBottom++;  //????oO␳ɂƂ肠g
            break;   
         }
         else 
         {
            j ++;
         }
      }   

         //J̒l[RO]LowlႩAꂪTime[0]łȂꍇ
         //̏ꍇ͒JO̒lɈړB
         //l̏ꍇ͎OłƂ肠悢

      FiboBottom = iLowest(NULL,0,MODE_LOW,FiboBottom,0);

   }

oldV = newV;

   int ticket;
 if (SendOK != false)
 { 
   if (FiboTop == 0 && FiboTop < FiboBottom)
   {
      if (Posi == "L") ClosePosi();
      if (Posi != "S" && iSAR(NULL,0,0.2,0.02,0) > Bid && iRSI(NULL,0,HANI,PRICE_CLOSE,0) >= 50){ ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,10,0,0,"TRIFDN",MAGIC,0,Blue); PlaySound (Symbol()+ "S.wav");}
         //ordersenderror
      if (ticket == -1)
      {
         GLerror = GetLastError();
         if (GLerror == 132) Sleep(600000);
         else if (GLerror == 134) SendOK = false;
         else Alert("OrderSendError(L)#",GLerror);
      }
      else
      {
         Posi = "S";
         End1 = false;
         End2 = false;
         End3 = false;
         SendOK = true;
      }
   }
   else if (FiboBottom <= 1 && FiboTop > FiboBottom)
   {
      if (Posi == "S") ClosePosi();
      if (Posi != "L" && iSAR(NULL,0,0.2,0.02,0) < Bid && iRSI(NULL,0,HANI,PRICE_CLOSE,0) <= 50){ ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,10,0,0,"TRIFDN",MAGIC,0,Red); PlaySound (Symbol()+ "L.wav");   }
         //ordersenderror
      if (ticket == -1)
      {
         GLerror = GetLastError();
         if (GLerror == 132) Sleep(600000);
         else if (GLerror == 134) SendOK = false;
         else Alert("OrderSendError(L)#",GLerror);
      }
      else
      {
         Posi = "L";
         End1 = false;
         End2 = false;
         End3 = false;
         SendOK = true;
      }
   }
   
   else if (High[FiboTop] + 60 * Point < Bid && FiboTop < FiboBottom)
   {
      if (posicount != 0) ClosePosi();
      End1 = false;
      End2 = false;
      End3 = false;
      SendOK = true;
   }
   else if (Low[FiboBottom] - 60 * Point > Bid && FiboTop > FiboBottom)
   {
      if (posicount != 0) ClosePosi();
      End1 = false;
      End2 = false;
      End3 = false;
      SendOK = true;
   }
   else if (High[FiboTop] - (High[FiboTop] - Low[FiboBottom]) * 0.372 > Bid && End2 == false && FiboTop < FiboBottom)
   {
      if (Posi == "S"  && iSAR(NULL,0,0.2,0.02,0) > Bid && iRSI(NULL,0,HANI,PRICE_CLOSE,0) >= 50){ ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,10,0,0,"TRIFDN",MAGIC,0,Blue); PlaySound (Symbol()+ "S.wav");}
         //ordersenderror
      if (ticket == -1)
      {
         GLerror = GetLastError();
         if (GLerror == 132) Sleep(600000);
         else if (GLerror == 134) SendOK = false;
         else Alert("OrderSendError(L)#",GLerror);
      }
      else
      {
         Posi = "S";
         End2 = true;
         SendOK = true;
      }
   }
   else if (Low[FiboBottom] + (High[FiboTop] - Low[FiboBottom]) * 0.372 < Bid && End2 == false && FiboTop > FiboBottom)
   {
      if (Posi == "L"  && iSAR(NULL,0,0.2,0.02,0) < Bid && iRSI(NULL,0,HANI,PRICE_CLOSE,0) <= 50){ ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,10,0,0,"TRIFDN",MAGIC,0,Red); PlaySound (Symbol()+ "L.wav");  }
         //ordersenderror
      if (ticket == -1)
      {
         GLerror = GetLastError();
         if (GLerror == 132) Sleep(600000);
         else if (GLerror == 134) SendOK = false;
         else Alert("OrderSendError(L)#",GLerror);
      }
      else
      {
         Posi = "L";
         End2 = true;
         SendOK = true;
      }
   }
   else if (High[FiboTop] - (High[FiboTop] - Low[FiboBottom]) * 0.49 > Bid && End3 == false && FiboTop < FiboBottom)
   {
      if (Posi == "S"  && iSAR(NULL,0,0.2,0.02,0) > Bid && iRSI(NULL,0,HANI,PRICE_CLOSE,0) >= 50){ ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,10,0,0,"TRIFDN",MAGIC,0,Blue); PlaySound (Symbol()+ "S.wav");}
         //ordersenderror
      if (ticket == -1)
      {
         GLerror = GetLastError();
         if (GLerror == 132) Sleep(600000);
         else if (GLerror == 134) SendOK = false;
         else Alert("OrderSendError(L)#",GLerror);
      }
      else
      {
         Posi = "S";
         End3 = true;
         SendOK = true;
      }
   }
   else if (Low[FiboBottom] + (High[FiboTop] - Low[FiboBottom]) * 0.49 < Bid && End3 == false && FiboTop > FiboBottom)
   {
      if (Posi == "L"  && iSAR(NULL,0,0.2,0.02,0) < Bid && iRSI(NULL,0,HANI,PRICE_CLOSE,0) <= 50){ ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,10,0,0,"TRIFDN",MAGIC,0,Red); PlaySound (Symbol()+ "L.wav");  }
         //ordersenderror
      if (ticket == -1)
      {
         GLerror = GetLastError();
         if (GLerror == 132) Sleep(600000);
         else if (GLerror == 134) SendOK = false;
         else Alert("OrderSendError(L)#",GLerror);
      }
      else
      {
         Posi = "L";
         End3 = true;
         SendOK = true;
      }
   }
   else if (High[FiboTop] - (High[FiboTop] - Low[FiboBottom]) * 0.61 > Bid && End1 == false && FiboTop < FiboBottom)
   {
      if (Posi == "S"  && iSAR(NULL,0,0.2,0.02,0) > Bid && iRSI(NULL,0,HANI,PRICE_CLOSE,0) >= 50){ ticket = OrderSend(Symbol(),OP_SELL,Lots,Bid,10,0,0,"TRIFDN",MAGIC,0,Blue); PlaySound (Symbol()+ "S.wav");}
         //ordersenderror
      if (ticket == -1)
      {
         GLerror = GetLastError();
         if (GLerror == 132) Sleep(600000);
         else if (GLerror == 134) SendOK = false;
         else Alert("OrderSendError(L)#",GLerror);
      }
      else
      {
         Posi = "S";
         End1 = true;
         SendOK = true;
      }
   }
   else if (Low[FiboBottom] + (High[FiboTop] - Low[FiboBottom]) * 0.61 < Bid && End1 == false && FiboTop > FiboBottom)
   {
      if (Posi == "L"  && iSAR(NULL,0,0.2,0.02,0) < Bid && iRSI(NULL,0,HANI,PRICE_CLOSE,0) <= 50){ ticket = OrderSend(Symbol(),OP_BUY,Lots,Ask,10,0,0,"TRIFDN",MAGIC,0,Red); PlaySound (Symbol()+ "L.wav");  }
         //ordersenderror
      if (ticket == -1)
      {
         GLerror = GetLastError();
         if (GLerror == 132) Sleep(600000);
         else if (GLerror == 134) SendOK = false;
         else Alert("OrderSendError(L)#",GLerror);
      }
      else
      {
         Posi = "L";
         End1 = true;
         SendOK = true;
      }
   }
 }
      

   
   Comment("Ă");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+


   //|WVN[Y
void ClosePosi()
{
   int kaisu = 0;                //[v񐔃`FbNp
   bool flgCloseChk = true;      //|WVN[Ysfalse
   int h;
   int k;
   int handle;
   
   
   while(true)
   {
      kaisu++;                   //[v񐔃JEgAbv
      CloseSig = false;          //N[Y̊x~낷

               //S|W̊mF[v
      k = OrdersTotal();
      for(h = k-1; h >= 0; h--)
      {
            //t[YoOC
         while (true)
         {
            if(IsTradeContextBusy())
            {
               Sleep(3000);
            }
            else
            {
               break;
            }
         }
               //G[H̃`FbN
         if(OrderSelect(h,SELECT_BY_POS,MODE_TRADES) == false)
         {
            continue;            //̃|WVցB
         }

               //ʒʉ݃yÃ͎|WVցB
         if(OrderSymbol() != Symbol()) continue;
      
               //LȊÕ|WV(yA)
               //I[_[N[Y
         if(OrderType() == OP_BUY)
         {
            flgCloseChk = OrderClose(OrderTicket(), OrderLots(),Bid,10,Orange);
               //I[_[N[YsAVOitrueɁB
            if (flgCloseChk == false)
            {  
               CloseSig = true;
            }
            else
            {
               PlaySound ("close.wav");
            }
         }
         if(OrderType() == OP_SELL)
         {
            flgCloseChk = OrderClose(OrderTicket(), OrderLots(),Ask,10,Indigo);
               //I[_[N[YsAVOitrueɁB
            if (flgCloseChk == false)
            {  
               CloseSig = true;
            }
            else
            {
               PlaySound ("close.wav");
            }
         }

      }
               //I[_[N[YSɏI邩A
               //K񐔈ȏニ[vI
      if(CloseSig == false || kaisu > 5) break;
   }
}